{
 main.pas

 This program shows how to use GSBMPLib with Delphi 3.
 Don`t forget to copy gs.dll and gsbmp.dll into the
 working directory before runing!

 (C) ENTROPYWARE, Alexander Simakov.

 Our site: http://www.entropyware.info/
 Support:  support@entropyware.info
 Author:   xander@entropyware.info
}

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;

type
  TfrmMain = class(TForm)
    gbFiles: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edtInput: TEdit;
    edtOutput: TEdit;
    btnOpen: TSpeedButton;
    btnSave: TSpeedButton;
    gbAction: TGroupBox;
    rbtnCompress: TRadioButton;
    rbtnDecompress: TRadioButton;
    gbQuality: TGroupBox;
    TrackBar: TTrackBar;
    lblBestSize: TLabel;
    lblBestQuality: TLabel;
    lblComperssionQuality: TLabel;
    lblQuality: TLabel;
    ProgressBar: TProgressBar;
    btnGo: TButton;
    btnExit: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    procedure TrackBarChange(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure rbtnDecompressClick(Sender: TObject);
    procedure rbtnCompressClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnGoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

// Export compression and decompression functions from the library
function gs_compress_bmp(in_path: PChar; out_path: PChar; quality: Integer; progress: Pointer): Integer; stdcall;
external 'gsbmp.dll' name 'gs_compress_bmp';

function gs_decompress_bmp(in_path: PChar; out_path: PChar; progress: Pointer): Integer; stdcall;
external 'gsbmp.dll' name 'gs_decompress_bmp';

function MessageBox(HWnd: Integer; Text, Caption: PChar; Flags: Integer): Integer; stdcall;
external 'user32.dll' name 'MessageBoxA';

implementation

{$R *.DFM}

// User supplied progress reporting function (declarated as stdcall)
procedure Progress(percent_done: Integer); stdcall;
begin
FrmMain.ProgressBar.Position := percent_done;
end;

procedure TfrmMain.TrackBarChange(Sender: TObject);
begin
lblQuality.Caption := IntToStr(TrackBar.Position);
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
Application.Terminate;
end;

procedure TfrmMain.rbtnDecompressClick(Sender: TObject);
begin
lblBestSize.Enabled := False;
lblBestQuality.Enabled := False;
lblComperssionQuality.Enabled := False;
lblQuality.Enabled := False;
TrackBar.Enabled := False;
end;

procedure TfrmMain.rbtnCompressClick(Sender: TObject);
begin
lblBestSize.Enabled := True;
lblBestQuality.Enabled := True;
lblComperssionQuality.Enabled := True;
lblQuality.Enabled := True;
TrackBar.Enabled := True;
end;

procedure TfrmMain.btnOpenClick(Sender: TObject);
begin
if OpenDialog.Execute then edtInput.Text := OpenDialog.FileName;
end;

procedure TfrmMain.btnSaveClick(Sender: TObject);
begin
if rbtnCompress.Checked = True then SaveDialog.DefaultExt := 'gs'
else SaveDialog.DefaultExt := 'bmp';
SaveDialog.FileName := '';
if SaveDialog.Execute then edtOutput.Text := SaveDialog.FileName;
end;

procedure TfrmMain.btnGoClick(Sender: TObject);
var res: Integer;
    InPath: array [0..1023] of Char;
    OutPath: array [0..1023] of Char;
begin

  // Convert string from Pascal-style to C-style
  StrPCopy(InPath, edtInput.Text);
  StrPCopy(OutPath, edtOutput.Text);

  if rbtnCompress.Checked = True then
  res := gs_compress_bmp(InPath, OutPath, TrackBar.Position, Addr(Progress))
  else
  res := gs_decompress_bmp(InPath, OutPath, Addr(Progress));

  ProgressBar.Position := 0;

  case res of
    0: MessageBox(0, 'Done!', 'GSBMPLib-DELPHI3', MB_ICONINFORMATION or MB_OK);
   -1: MessageBox(0, 'Can`t open file', 'GSBMPLib-DELPHI3', MB_ICONERROR or MB_OK);
   -2: MessageBox(0, 'Can`t create file', 'GSBMPLib-DELPHI3', MB_ICONERROR or MB_OK);
   -3: MessageBox(0, 'Not enough memory', 'GSBMPLib-DELPHI3', MB_ICONERROR or MB_OK);
   -4: MessageBox(0, 'Internal library error', 'GSBMPLib-DELPHI3', MB_ICONERROR or MB_OK);
   -5: MessageBox(0, 'Unsupported or damaged BMP file', 'GSBMPLib-DELPHI3', MB_ICONERROR or MB_OK);
   -6: MessageBox(0, 'Damaged or invalid GS file header', 'GSBMPLib-DELPHI3', MB_ICONERROR or MB_OK);
  end;
end;

end.
