/*
 * gs.c
 *
 * This program shows how to use GSBMPLib with C/C++.
 * Don`t forget to copy gs.dll and gsbmp.dll into the
 * working directory before runing!
 *
 * (C) ENTROPYWARE, Alexander Simakov.
 *
 * Our site: http://www.entropyware.info/
 * Support:  support@entropyware.info
 * Author:   xander@entropyware.info
 */

#include <stdio.h>
#include "gsbmp\gsbmplib.h"

void GS_API progress(int percent_done)
{
  fprintf(stderr, "\rProgress: %d%% done", percent_done);
  fflush(stderr);
}

void printf_usage()
{
  printf("\nUsage: <gsbmptst.exe> <c|d> [0<=q<=100] <in_file> <out_file>\n");
  printf("Example 1: gsbmptst.exe c 65 test.bmp test.gs\n");
  printf("Example 2: gsbmptst.exe d photo.gs photo.bmp\n");
  exit(1);
}

void main(int argc, char *argv[])
{
  int res;

  printf("\nGSBMPLib test, (C) ENTROPYWARE, Alexander Simakov.\n");

  if ((argc == 5) && (*argv[1] == 'c') && (atoi(argv[2]) >= 0) && (atoi(argv[2]) <= 100))
    res = gs_compress_bmp(argv[3], argv[4], atoi(argv[2]), progress);
  else if ((argc == 4) && (*argv[1] == 'd'))
    res = gs_decompress_bmp(argv[2], argv[3], progress);
  else printf_usage();

  printf("\n");

  switch (res)
  {
    case GSBMP_OK:
         break;

    case GSBMP_OPEN_ERROR: printf("Can`t open file.\n");
         break;

    case GSBMP_CREATE_ERROR: printf("Can`t create file.\n");
         break;

    case GSBMP_MEMORY_ERROR: printf("Not enough memory.\n");
         break;

    case GSBMP_INTERNAL_ERROR: printf("Internal library error.\n");
         break;

    case GSBMP_DAMAGED_BMP: printf("Unsupported or damaged BMP file.\n");
         break;

    case GSBMP_DAMAGED_GS: printf("Damaged GS file header.\n");
         break;
  }
}
